/*--------------------------------------------------------------*/
//File: MAX7221Ӧ
//Date: 09-1-8
//Time: 18:58


/*--------------------------------------------------------------*/
/*MAX7221  
Serially Interfaced, 8-Digit LED Display Drivers

DIN ʱд
DIN Serial-Data Input. Data is loaded into the internal 16-bit 
shift register on CLKs rising edge.

/CS Ƭѡ
Chip-Select Input. Serial data is loaded into the shift register 
while /CS is low. The last 16 bits of serial data are latched on 
/CSs rising edge.

CLK ʱӣдĴ½شDOUT
Serial-Clock Input.On CLKs rising edge, data is shifted into 
the internal shift register. On CLKs falling edge, data is 
clocked out of DOUT. On the MAX7221, the CLK input is active 
only while /CS is low.

Register Address Map
No-Op			0x00 	ֻеλЧ
Digit0			0x01	λΪ޹λ
Digit1			0x02
Digit2			0x03
Digit3			0x04
Digit4			0x05
Digit5			0x06
Digit6			0x07
Digit7			0x08
Decode Mode		0x09
Intensity		0x0a
Scan Limit		0x0b
Shutdown 		0x0c
Display Test	0x0f

Shutdown Register    (Address (Hex) = 0xXC)
Shutdown Mode		0x00
Normal Operation	0x01

Decode-Mode Register (Address (Hex) = 0xX9)
No decode for digits 7-0		0x00
Code B decode for digits 7-0  	0xFF 
Code B decode for digit 0
No decode for digits 7-1		0x01
Code B decode for digits 3-0 
No decode for digits 7-4		0x0f
The decimal point is set by bit D7 = 1

Intensity Register   (Address (Hex) = 0xXA)
DUTY CYCLE 			 HEX CODE 
1/16~15/16  		 0xx0~0xxf

Scan-Limit Register  (Address (Hex) = 0xXB)
SCAN LIMIT			 HEX CODE
Display digit 0		 0xx0
Display digits 0&1	 0xx1
...					 ...
Display digits 0~7	 0xx7

Display-Test Register(Address (Hex) = 0xXF)
Normal Operation	 0xx0
Display Test Mode	 0xx1	
*/


/*--------------------------------------------------------------*/
//ֹظ
#ifndef __MAX7221_H__
#define __MAX7221_H__


/*--------------------------------------------------------------*/
//ӿڶ
sbit MAX7221_DIN = P1^0;		//
sbit MAX7221_CS  = P1^1;		//
sbit MAX7221_CLK = P1^2;		//ʱ



/*--------------------------------------------------------------*/
//ĴԼزú궨

//BCDģʽ
#define Decode_Mode		0x09		
//
#define Decode_None 	0x00		//
#define Decode_0		0x01		//ֻDigit 0
#define Decode_0_3		0x0f		//ֻDigit 0~3
#define Decode_All		0xff		//


//ʾռձȣȵ
#define Intensity		0x0a		
//0~15ʮȵ


//ʾλ
#define Scan_Limit		0x0b
//0~7ӦDigit 0~7ֻʾλ


//ʾ
#define Show_Power		0x0c
//
#define Show_Off		0x00		//ʾر
#define Show_On			0x01		//ʾ
		

//ʾԣжζ
//ע⣺Ϻ󣬱رղԣܽʾһֱΪ״̬
#define Show_Test		0x0f
//
#define Test_Off		0x00
#define	Test_On			0x01		


/*--------------------------------------------------------------*/
//Ҫʾ		   
unsigned char code seg [] = {0x7E,0x30,0x6D,0x79,0x33,0x5B,0x5F,0x70,0x7F,0x7B};
unsigned char code dat1[] = {5,2,0,1,3,1,4,3+128}; //С128
unsigned char code dat2[] = {"52013148"};
unsigned char code dat3[] = {1,3,1,4,5,2,0,8};

/*--------------------------------------------------------------*/
//MAX7221д8λ(ڲ)
void Write8_MAX7221(unsigned char dat)
{
	unsigned char i;
	for(i = 8; i > 0; i--)
	{
		MAX7221_CLK = 0;
		MAX7221_DIN = (bit)(dat & 0x80);		
		MAX7221_CLK = 1;
		dat <<= 1;
	}
}


/*--------------------------------------------------------------*/
//ʱ1000000+1us 
void delay1000ms(void)
{
    unsigned char i,j,k;
    for(i=167;i>0;i--)
    for(j=171;j>0;j--)
    for(k=16;k>0;k--);
}


/*--------------------------------------------------------------*/
//MAX7221ָĴַд
void Write_MAX7221(unsigned char add, unsigned char dat)
{
	MAX7221_CS = 0;
	Write8_MAX7221(add);		//дĴַ
	Write8_MAX7221(dat);		//дò
	MAX7221_CS = 1;
}


/*--------------------------------------------------------------*/
//MAX7221ʼ
void Initial_MAX7221(void)
{
	Write_MAX7221(Decode_Mode, Decode_All);	//BCD뷽ʽ8λ
	Write_MAX7221(Intensity,   0x0f);		//16ȵڣ
	Write_MAX7221(Scan_Limit,  0x07);		//ɨλ8λɨ
	Write_MAX7221(Show_Power,  Show_On);	//ʾأʾ
	Write_MAX7221(Show_Test,   Test_Off);	//ʾԣ
}


/*--------------------------------------------------------------*/
//λʾ
//ݲ
//pos:	λãӵλλΪ1-8
//dat:	֣0-9
//dot:	С㣬01С
//ͼģʽùɨλͿ0 ^_^
void DisplayP_MAX7221(unsigned char pos, unsigned char dat, bit dot)
{
	Write_MAX7221(Decode_Mode, Decode_None);//
	Write_MAX7221(Scan_Limit,  0x07);		//ɨλ8λɨ
	if(dot) dat += 128;						//С
	Write_MAX7221(pos, seg[dat]);	
}



/*--------------------------------------------------------------*/
//λʾ
//ݲ
//pos:	λãӵλλΪ1-8
//dat:	֣0-99
//ͼģʽùɨλͿ0 ^_^
void DisplayPD_MAX7221(unsigned char pos, unsigned char dat)
{
	unsigned char x,y;
	x = dat/10;
	y = dat%10;
	Write_MAX7221(Decode_Mode, Decode_None);//
	Write_MAX7221(Scan_Limit,  0x07);		//ɨλ8λɨ
	Write_MAX7221(pos,  seg[x]);
	Write_MAX7221(pos-1,seg[y]);	
}



/*--------------------------------------------------------------*/
//MAX7221ʾַʽ
/*void DisplayS_MAX7221(unsigned char *dat)
{
	unsigned char i, k=0, *p = dat;			//ʼҪ!!!
	while(*p) {p++;  k++;}					//ַ
	Write_MAX7221(Scan_Limit, k-1);			//ɨλk-1
	for(i = 0; i < k ; i++)				
	{										//дһλ
		Write_MAX7221(i+1, *(dat+k-1-i));	//48 = 32 + 16 ֱΪD5D4
											//MAX7221BCDʽʾʱֻλй
	}										//λ޹أ*datɲؼȥ48
}
*/


/*--------------------------------------------------------------*/
//MAX7221ʾַʽ鷽ʽҪֶС
void DisplayAS_MAX7221(unsigned char *dat,unsigned char n)
{
	unsigned char i;
	Write_MAX7221(Scan_Limit, n-1);			//ɨλn
	for(i = 0; i < n ; i++)				
	{										//дһλ
		Write_MAX7221(i+1, *(dat+n-1-i));	//48 = 32 + 16 ֱΪD5D4
											//MAX7221BCDʽʾʱֻλй
	}										//λ޹أ*datɲؼȥ48
}


/*--------------------------------------------------------------*/
//MAX7221ʾ鷽ʽַʽ8λ̶ʾ
void DisplayAS8_MAX7221(unsigned char *dat)
{
	unsigned char i;
	Write_MAX7221(Scan_Limit, 7);			//ɨλ8
	for(i = 0; i < 8; i++)
	{
		Write_MAX7221(i+1, *(dat+7-i));
	}
}


/*--------------------------------------------------------------*/
//MAX7221ʾԼͼΣ鷽ʽ
/*void DisplayG_MAX7221(unsigned char *dat)
{
	unsigned char i;
	Write_MAX7221(Decode_Mode, Decode_None);//
	Write_MAX7221(Scan_Limit, 7);			//ɨλ8
	for(i = 0; i < 8; i++)
	{
		Write_MAX7221(i+1, *(dat+7-i));
	}
}


/*--------------------------------------------------------------*/
//MAX7221ʾ鷽ʽ,ͼģʽùɨλͿ0 ^_^
void DisplayG_MAX7221(unsigned char *dat)
{
	unsigned char i;
	Write_MAX7221(Decode_Mode, Decode_None);//
	Write_MAX7221(Scan_Limit, 7);			//ɨλ8
	for(i = 0; i < 8; i++)
	{
		Write_MAX7221(i+1, seg[dat[i]]);
	}
}


/*--------------------------------------------------------------*/
//MAX7221ʾַʽ16λΪ65535
void DisplayD_MAX7221(unsigned int dat)
{
	unsigned char i=0;				//ʼҪ!!!	
	unsigned char k[5];
	for(i = 0; i < 5; i++) k[i]=0;
	i = 0;
	while(dat / 10)
	{
		k[4-i] = dat%10 + 48;		//תΪַ
		dat /= 10;
		i++;
	}
	k[4-i] = dat+48;
	DisplayAS_MAX7221(k,5);
}


/*--------------------------------------------------------------*/
//ʾ
void Display_Test(void)
{
	Write_MAX7221(Show_Test,   Test_On);	//ʾԣ
	delay1000ms();
	Write_MAX7221(Show_Test,   Test_Off);	//ʾԣ
}


/*--------------------------------------------------------------*/
//ݼĴ
void ClearRam_MAX7221(unsigned char n)
{
	unsigned char i;
	for(i = n; i > 0; i--)
	Write_MAX7221(i, 0);
}


/*--------------------------------------------------------------*/
#endif 



/*--------------------------------------------------------------*/
//ʾ
/*void main(void)
{

	unsigned char t[8],i,j;

	Initial_MAX7221();
	Display_Test();

	DisplayD_MAX7221(123);			//֣65535
	delay1000ms();	

	DisplayAS8_MAX7221(dat1);		//
	delay1000ms();
	DisplayAS8_MAX7221(dat2);		//ַ
	delay1000ms();
	
	DisplayG_MAX7221(dat3);
	delay1000ms();
	
	
	ClearRam_MAX7221(8);
	delay1000ms();

	for(i = 8; i > 0; i--)
	{
		for(j = 0; j <= i; j++)
			{
				DisplayP_MAX7221(i,j,0);
				delay1000ms();
			}
	}

	for(i = 8; i > 0; i--)
	{
		for(j = 1; j <=i ; j++)
			{
				DisplayP_MAX7221(j,i,0);
				delay1000ms();
			}
	}


	for(i = 8; i > 0; i--)
	{
		for(j = 1; j <=i ; j++)
			{
				ClearRam_MAX7221(i);
				DisplayP_MAX7221(j,i,0);
				delay1000ms();			
			}
	}

	Write_MAX7221(Decode_Mode, Decode_All);//
	while(t[0]<15)
	{
		for(i = 0; i < 8; i++) t[i]++;
		DisplayAS8_MAX7221(t);
		delay1000ms();
	}

	DisplayAS8_MAX7221("89272965");	//ַ飬̶8
	delay1000ms();

	DisplayAS_MAX7221("89272965",4);//ַ飬ֶ
	delay1000ms();

	ClearRam_MAX7221(8);
	delay1000ms();

loop:
	for(i = 0; i <= 60; i++)
	{
		DisplayPD_MAX7221(5,i);
		delay1000ms();
	}
	for(i = 59; i > 0; i--)
	{
		DisplayPD_MAX7221(5,i);
		delay1000ms();
	}
	goto loop;
}
/*--------------------------------------------------------------*/